#!/usr/bin/perl

#################################################################
# WebGrams 1.1
# by Les "Buddy" VanBrunt
# vanbrunt@vanbrunt.com
#
# This program has been released under GPL.  For information,
# see the COPYING file included with this code.
#
# To configure this program, edit the webgram_variables.pl file.
# The .tpl files are HTML templates that can be changed to change
# the look of the pages.  Please leave a link  to 
# http://www.vanbrunt.com/webgrams at the bottom of each page. 
#################################################################

# Read in the variables
require("webgram_variables.pl");

# Get the input
&GetInput;

# Let the program do its thing depending on the input
###############

if ($FORM{'action'} eq "") {
    open(HTML,"default.tpl");
    print "Content-type: text/html\n\n";
    while(<HTML>) {

        ## Replace the variables
        $line = $_;
        $line =~ s/\$imageurl/$imageurl/g;
        $line =~ s/\$cgiurl/$cgiurl/g;
        ## End Replace

        print $line;
    }
    close(HTML);
}

if ($FORM{'action'} eq "view") {

    # Do not allow certain charcters
    $FORM{'password'} =~ s/\%//g;
    $FORM{'password'} =~ s/\"//g;
    $FORM{'password'} =~ s/\'//g;
    $FORM{'password'} =~ s/\t//g;

    dbmopen (%arr, "$datadir/PassDb", 0666) || die "Could not open $datadir/PassDb";
   

    if (!($arr{$FORM{'code'}} eq $FORM{'password'})) {
        print "Content-type: text/html\n\n";
        print "<HTML><BODY><H1>Error</H1>\n";
        print "<H4>The code and password you entered do not match</H4></BODY></HTML>\n";
        dbmclose (%arr);
        exit;
    } else {
        dbmclose (%arr);
        dbmopen (%card, "$datadir/CardDb", 0666) || die "Could not open $datadir/CardDb";
        @pairs = split(/\t/, $card{$FORM{'code'}});
        foreach $var (@pairs) {
            ($var1, $var2) = split(/=/, $var, 2);
            $FORM{$var1} = $var2;
        }

        # Need to clear this variable
        $FORM{'action'} = "";

        &Decode;
        $FORM{'message'} =~ s/\n/<br>/g;

        $pic = @image[$FORM{'pic'}];
        if ($FORM{'greeting'} ne "none") {
            $greettag = "<IMG SRC=\"$imageurl/$greeting[$FORM{'greeting'}]\">";
        }
        print "Content-type: text/html\n\n";

        open (HTML,"view.tpl");
        while (<HTML>) {
            $line = $_;
            &ChangeVars;
            print $line;
        }
        close (HTML);
        dbmclose(%card);
    }
}

if ($FORM{'action'} eq "preview") {

    &CheckReq;
    &MakeVars;

    $FORM{'message'} =~ s/\n/<br>/g;
    print "Content-type: text/html\n\n";
    open(HTML,"preview.tpl");
    while (<HTML>) {
        $line = $_;
        &ChangeVars;
        print $line;
    }
}

if ($FORM{'action'} eq "build") {

    &MakeVars;

    open(HTML,"build$step.tpl");
    print "Content-type: text/html\n\n";
    while(<HTML>) {
        $line = $_;
        &ChangeVars;
        print $line;
    }
    close(HTML);
}

if ($FORM{'action'} eq "send") {

    &GetDateCode;
    &Encode;

    # Get the next card number

    dbmopen (%num, "$datadir/NumDb", 0666) || die "Could not open $datadir/NumDb";
    $num{'number'} ++;
    $number = $num{'number'};
    dbmclose (%num);

    # Enter Data into the database

    dbmopen (%arr, "$datadir/PassDb", 0666) || die "Could not open $datadir/PassDb";
    $arr{$number} = $FORM{'password'};
    dbmclose (%arr);

    dbmopen (%card, "$datadir/CardDb", 0666) || die "Could not open $datadir/CardDb";
    foreach $var (keys(%FORM)) {
        $card{$number} = $card{$number}."$var=$FORM{$var}\t";
    }
    $card{$number}."datecode=$datecode\t";
    dbmclose (%card);

    # Send the e-mail notification

    open (MAIL,"|$mailprog -t");
    open (MESSAGE,"email.tpl");

    while (<MESSAGE>) {
        $line = $_;
        &ChangeVars;
        print MAIL $line;
    }

    close (MAIL);
    close (MESSAGE);

    print "Content-type: text/html\n\n";
    open (HTML,"sent.tpl");
    while (<HTML>) {
        $line = $_;
        &ChangeVars;
        print $line;
    }

}

###############
# Subroutines
###############

sub GetInput {
    
   # Get the input
   if($ENV{'REQUEST_METHOD'} eq "POST"){
      read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
   }
   if($ENV{'REQUEST_METHOD'} eq "GET"){
      $input=$ENV{'QUERY_STRING'};
   }

   # Split the name-value pairs
   @pairs = split(/&/, $input);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);           
   
   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   $FORM{$name} = $value;
   }

   if ($FORM{'password'} ne "") {
   $FORM{'password'} =~ s/ //g;
   $FORM{'password'} =~ s/\%//g;
   $FORM{'password'} =~ s/\"//g;
   $FORM{'password'} =~ s/\'//g;
   }
}


sub ChangeVars {
        $line =~ s/\$imageurl/$imageurl/g;
        $line =~ s/\$cgiurl/$cgiurl/g;
        $line =~ s/\$varstring/$varstring/g;
        $line =~ s/\$pic/$pic/g;
        $line =~ s/\$greettag/$greettag/g;
        $line =~ s/\$hiddenfields/$hiddenfields/g;
	$line =~ s/\$sender_name/$FORM{'sender_name'}/g;
	$line =~ s/\$sender_email/$FORM{'sender_email'}/g;
	$line =~ s/\$recipient_name/$FORM{'recipient_name'}/g;
	$line =~ s/\$recipient_email/$FORM{'recipient_email'}/g;
        $line =~ s/\$message/$FORM{'message'}/g;
        $line =~ s/\$enc-sender_name/$enc{'sender_name'}/g;
        $line =~ s/\$enc-sender_email/$enc{'sender_email'}/g;
        $line =~ s/\$enc-recipient_name/$enc{'recipient_name'}/g;
        $line =~ s/\$enc-recipient_email/$enc{'recipient_email'}/g;
        $line =~ s/\$enc-message/$enc{'message'}/g;
        $line =~ s/\$password/$FORM{'password'}/g;
        $line =~ s/\$number/$number/g;


        for($i=0;$i<=$#thumb;$i++) {
            $line =~ s/\$thumb\[$i\]/$thumb[$i]/g;
        }

        for($i=0;$i<=$#image;$i++) {
            $line =~ s/\$image\[$i\]/$image[$i]/g;
        }

        for($i=0;$i<=$#greeting;$i++) {
            $line =~ s/\$greeting\[$i\]/$greeting[$i]/g;
        }

}

sub MakeVars {
    $step = $FORM{'step'};
    delete($FORM{'step'});
    delete($FORM{'action'});
    $pic = $image[$FORM{'pic'}];
    if ($FORM{'greeting'} ne "none") {
        $greettag = "<IMG SRC=\"$imageurl/$greeting[$FORM{'greeting'}]\">";
    }

    foreach $var (keys(%FORM)) {
        $dor{$var} = $FORM{$var};
        $dor{$var} =~ s/\%/\%1/g;
        $dor{$var} =~ s/\"/\%2/g;
        $dor{$var} =~ s/\'/\%3/g;
        $dor{$var} =~ s/\t/\%4/g;

        $varstring = $varstring."$var=$FORM{$var}\&";
        $hiddenfields = $hiddenfields."<INPUT TYPE=\"hidden\" NAME=\"$var\" VALUE=\"$dor{$var}\">\n";
    }
    chop($varstring);
}

sub CheckReq {
    foreach $var (keys(%FORM)) {
        if (length($FORM{$var}) == 0) {
            print "Content-type: text/html\n\n";
            print "<HTML><HEAD><TITLE>ERROR</TITLE></HEAD>\n";
            print "<BODY BGCOLOR=FFFFFF>\n";
            print "<H1>ERROR</H1>\n";
            print "<H3>All fields must be filled in.</H3>\n";
            print "Please go back and complete all fields.\n";
            print $varstring;
            print "</BODY></HTML>\n";
            exit;
        }
    }
}

sub Encode{
    foreach $var (keys(%FORM)) {
        $enc{$var} = $FORM{$var};
        $enc{$var} =~ s/\%/\%1/g;
        $enc{$var} =~ s/\"/\%2/g;
        $enc{$var} =~ s/\'/\%3/g;
        $enc{$var} =~ s/\t/\%4/g;
    }
}

sub Decode{
    foreach $var (keys(%FORM)) {
        $dec{$var} = $FORM{$var};
        $FORM{$var} =~ s/\%1/\%/g;
        $FORM{$var} =~ s/\%2/\"/g;
        $FORM{$var} =~ s/\%3/\'/g;
        $FORM{$var} =~ s/\%4/\t/g;
    }
}

sub GetDateCode {
$date = `$dateprog +"%m/%d/%y"`;
chop($date);
($month, $day, $year) = split(/\//, $date, 3);
@month_days = (0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
$datecode = (($year - 97) * 365) + ($day) + ($month_days[$month]);
}
